using System.Windows;
using System.Windows.Input;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// Ŀ Ŀ 
    /// </summary>
    public static class CustomFocusScope
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Dependency Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Ŀ Ŀ   ÷ Ӽ - IsCustomFocusScopeProperty

        /// <summary>
        /// Ŀ Ŀ   ÷ Ӽ
        /// </summary>
        public static readonly DependencyProperty IsCustomFocusScopeProperty = DependencyProperty.RegisterAttached
        (
            "IsCustomFocusScope",
            typeof(bool),
            typeof(CustomFocusScope),
            new UIPropertyMetadata(false, IsCustomFocusScopePropertyChangedCallback)
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Ŀ Ŀ   ϱ - GetIsCustomFocusScope(element)

        /// <summary>
        /// Ŀ Ŀ   ϱ
        /// </summary>
        /// <param name="element">Ʈ</param>
        /// <returns>Ŀ Ŀ  </returns>
        public static bool GetIsCustomFocusScope(UIElement element)
        {
            return (bool)element.GetValue(IsCustomFocusScopeProperty);
        }

        #endregion
        #region Ŀ Ŀ   ϱ - SetIsCustomFocusScope(element, value)

        /// <summary>
        /// Ŀ Ŀ   ϱ
        /// </summary>
        /// <param name="element">Ʈ</param>
        /// <param name="value">Ŀ Ŀ  </param>
        public static void SetIsCustomFocusScope(UIElement element, bool value)
        {
            element.SetValue(IsCustomFocusScopeProperty, value);
        }

        #endregion

        #region   Ȱ Ʈ Ŀ ϱ - SetFocusOnActiveElementInScope(focusScopeElement)

        /// <summary>
        ///   Ȱ Ʈ Ŀ ϱ
        /// </summary>
        /// <param name="focusScopeElement">Ŀ  Ʈ</param>
        public static void SetFocusOnActiveElementInScope(UIElement focusScopeElement)
        {
            IInputElement focusedElement = FocusManager.GetFocusedElement(focusScopeElement);

            if(focusedElement != null)
            {
                Keyboard.Focus(focusedElement);
            }
            else
            {
                focusScopeElement.MoveFocus(new TraversalRequest(FocusNavigationDirection.First));
            }
        }

        #endregion
        
        //////////////////////////////////////////////////////////////////////////////// Private
        
        #region Ŀ Ŀ   Ӽ  ݹ óϱ - IsCustomFocusScopePropertyChangedCallback(d, e)

        /// <summary>
        /// Ŀ Ŀ   Ӽ  ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="e">̺Ʈ </param>
        private static void IsCustomFocusScopePropertyChangedCallback(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            UIElement element = d as UIElement;

            if(element == null)
            {
                return;
            }
            
            if((bool)e.NewValue)
            {
                FocusManager.SetIsFocusScope(element, true);

                element.GotKeyboardFocus += element_GotKeyboardFocus;
            }
            else
            {
                FocusManager.SetIsFocusScope(element, false);

                element.GotKeyboardFocus -= element_GotKeyboardFocus;
            }
        }

        #endregion
        #region Ʈ Ű Ŀ ȹ óϱ - element_GotKeyboardFocus(sender, e)

        /// <summary>
        /// Ʈ Ű Ŀ ȹ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private static void element_GotKeyboardFocus(object sender, KeyboardFocusChangedEventArgs e)
        {
            IInputElement focusedElement = e.NewFocus;

            for(DependencyObject d = focusedElement as DependencyObject; d != null; d = VisualTreeHelper.GetParent(d))
            {
                if(FocusManager.GetIsFocusScope(d))
                {
                    d.SetValue(FocusManager.FocusedElementProperty, focusedElement);

                    if(!(bool)d.GetValue(IsCustomFocusScopeProperty))
                    {
                        break;
                    }
                }
            }
        }

        #endregion
    }
}