﻿using System.Reflection;
using System.Windows;
using System.Windows.Input;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.groupBox1.MouseDown += groupBox1_MouseDown;
            this.groupBox2.MouseDown += groupBox2_MouseDown;
            this.groupBox3.MouseDown += groupBox3_MouseDown;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 그룹 박스 1 마우스 DOWN 처리하기 - groupBox1_MouseDown(sender, e)

        /// <summary>
        /// 그룹 박스 1 마우스 DOWN 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void groupBox1_MouseDown(object sender, MouseButtonEventArgs e)
        {
            object keyboardNavigation = typeof(KeyboardNavigation).InvokeMember
            (
                "Current",
                BindingFlags.Static | BindingFlags.NonPublic | BindingFlags.GetProperty,
                null,
                null,
                null
            );

            object activeElement = typeof(KeyboardNavigation).InvokeMember
            (
                "GetActiveElement",
                BindingFlags.Instance | BindingFlags.NonPublic | BindingFlags.InvokeMethod,
                null,
                keyboardNavigation,
                new object[] { this.groupBox1 }
            );

            IInputElement focusedElement = activeElement as IInputElement;

            if(focusedElement != null)
            {
                Keyboard.Focus(focusedElement);
            }
            else
            {
                this.groupBox1.MoveFocus(new TraversalRequest(FocusNavigationDirection.First));
            }
        }

        #endregion
        #region 그룹 박스 2 마우스 DOWN 처리하기 - groupBox2_MouseDown(sender, e)

        /// <summary>
        /// 그룹 박스 2 마우스 DOWN 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void groupBox2_MouseDown(object sender, MouseButtonEventArgs e)
        {
            IInputElement focusedElement = FocusManager.GetFocusedElement(this.groupBox2);

            if(focusedElement != null)
            {
                Keyboard.Focus(focusedElement);
            }
            else
            {
                this.groupBox2.MoveFocus(new TraversalRequest(FocusNavigationDirection.First));
            }
        }

        #endregion
        #region 그룹 박스 3 마우스 DOWN 처리하기 - groupBox3_MouseDown(sender, e)

        /// <summary>
        /// 그룹 박스 3 마우스 DOWN 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void groupBox3_MouseDown(object sender, MouseButtonEventArgs e)
        {
            CustomFocusScope.SetFocusOnActiveElementInScope(this.groupBox3);
        }

        #endregion
    }
}